SystemOrganization addCategory: #SqueakSVNPlugins!

SmartSyntaxInterpreterPlugin subclass: #SqueakSVNPlugin
	instanceVariableNames: 'pool ctx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVNPlugins'!

!SqueakSVNPlugin class methodsFor: 'translation' stamp: 'rkrk 3/17/2008 03:40'!
declareCVarsIn: cg

	super declareCVarsIn: cg.
	"cg addHeaderFile: ' ---- squeakSVNWrapper.h -----'."
	cg
		var: 'pool' declareC: 'apr_pool_t *pool';
		var: 'ctx' declareC: 'svn_client_ctx_t *ctx'.
	cg
		addHeaderFile: '"svn_string.h"';
		addHeaderFile: '"svn_client.h"';
		addHeaderFile: '"svn_cmdline.h"';
		addHeaderFile: '"svn_pools.h"'.! !

!SqueakSVNPlugin methodsFor: 'helper' stamp: 'rkrk 3/13/2008 22:51'!
callocWrapper: count size: objectSize
	"Copied from OSProcessPlugin"
	"Using malloc() and calloc() is something I would like to avoid, since it is
	likely to cause problems some time in the future if somebody redesigns
	object memory allocation. This wrapper just makes it easy to find senders
	of calloc() in my code. -dtl"

	self returnTypeC: 'void *'.
	^ self cCode: 'calloc(count, objectSize)'! !

!SqueakSVNPlugin methodsFor: 'helper' stamp: 'rkrk 2/27/2008 00:57'!
convertCStringToOop: aCString
	"Answer a new String copied from a null-terminated C string.
	Caution: This may invoke the garbage collector."

	| len newString |
	self var: 'aCString' type: 'const char *'.
	len := self strlen: aCString.
	newString := interpreterProxy
		instantiateClass: interpreterProxy classString
		indexableSize: len.
	self st: (interpreterProxy arrayValueOf: newString)
		rn: aCString
		cpy: len. "(char *)strncpy()"
	^ newString! !

!SqueakSVNPlugin methodsFor: 'helper' stamp: 'rkrk 3/13/2008 23:10'!
convertOopToCString: aString
	"Copied from OSProcessPlugin
	Free the result !!!!!!"

	"Answer a new null-terminated C string copied from aString. The C string
	is allocated from the C runtime heap. See transientCStringFromString for
	a version which allocates from object memory.
	Caution: This may invoke the garbage collector."

	| len sPtr cString |
	self returnTypeC: 'char *'.
	self var: 'sPtr' declareC: 'char *sPtr'.
	self var: 'cString' declareC: 'char *cString'.
	self var: 'len' declareC: 'size_t len'.
	sPtr := interpreterProxy arrayValueOf: aString.
	len := interpreterProxy sizeOfSTArrayFromCPrimitive: sPtr.
	cString := self callocWrapper: len + 1 size: 1.			"Space for a null terminated C string."
	self
		cCode: '(char *) strncpy (cString, sPtr, len)';	"Copy the string."
		cCode: 'cString[len] = ''\0'''.	"Terminate with null"
	^ cString! !

!SqueakSVNPlugin methodsFor: 'initialize' stamp: 'rkrk 3/16/2008 23:16'!
initialiseModule

	self export: true.
	self writeTextToOutputFile: 'Beginning  initialize of SqueakSVNPlugin'.
	self
		cCode: 'initialize(&pool, &ctx)';
		cCode: 'authenticate(&pool, &ctx)'.
	self writeTextToOutputFile: 'Initialize  of SqueakSVNPlugin complete'.
	^ true
! !

!SqueakSVNPlugin methodsFor: 'old' stamp: 'rkrk 3/14/2008 01:50'!
onlyATest

	| result |
	self export: true.
	self var: #result declareC: 'char *result'.
	result := self test.
	interpreterProxy
		pop: 1
		thenPush: (self convertCStringToOop: result).! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/17/2008 17:35'!
putAprDate: date in: arrayPtr at: index

	| dateString|
	self
		var: #index type: 'int';
		var: #date type: 'apr_time_t';
		var: #arrayPtr type: 'sqInt **';
		var: #dateString declareC: 'char dateString[APR_CTIME_LEN] '.

	date = nil ifTrue: [^ nil].
	self cCode: 'apr_ctime(dateString, date)'.
	self putCString: dateString in: arrayPtr at: index.! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/17/2008 16:47'!
putCString: cstring in: arrayPtr at: index

	| stringOop |
	self
		var: #cstring type: 'const char *';
		var: #index type: 'int';
		var: #arrayPtr type: 'sqInt**'.
	self	var: #stringOop declareC: 'sqInt stringOop'.

	cstring = nil ifTrue: [^ nil].
	self writeTextToOutputFile: cstring.
	stringOop := self convertCStringToOop: cstring.
	self cCode: '(*arrayPtr)[index] = stringOop'.! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/17/2008 16:58'!
putRevision: revision in: arrayPtr at: index

	| revisionOop |
	self
		var: #index type: 'int';
		var: #revision type: 'svn_revnum_t';
		var: #arrayPtr type: 'sqInt **';
		var: #revisionOop declareC: 'sqInt revisionOop'.

	revision = nil ifTrue: [^ nil].
	self writeIntToOutputFile: revision.
	
	revisionOop := interpreterProxy integerObjectOf: revision.
	self cCode: '(*arrayPtr)[index] = revisionOop'.! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/17/2008 21:34'!
putSchedule: schedule in: arrayPtr at: index

	self
		var: #index type: 'int';
		var: #schedule type: 'svn_wc_schedule_t';
		var: #arrayPtr type: 'sqInt **'.

	self writeIntToOutputFile: schedule.
	schedule = nil ifTrue: [^ nil].
	(self cCode: 'schedule == svn_wc_schedule_normal' ) 	ifTrue: [self putCString: 'normal' 	in: arrayPtr at: index.].
	(self cCode: 'schedule == svn_wc_schedule_add' )		ifTrue: [self putCString: 'add' 		in: arrayPtr at: index.].
	(self cCode: 'schedule == svn_wc_schedule_delete' )		ifTrue: [self putCString: 'delete' 	in: arrayPtr at: index.].
	(self cCode: 'schedule == svn_wc_schedule_replace' )	ifTrue: [self putCString: 'replace' 	in: arrayPtr at: index.].! !

!SqueakSVNPlugin methodsFor: 'shutdown' stamp: 'rkrk 3/17/2008 04:06'!
shutdownModule

	self export: true.
	self writeTextToOutputFile: 'Beginning  shutdown of SqueakSVNPlugin'.
	"Free the apr memory pool"
	self cCode: 'freeMemory(&pool)'.
	
	self writeTextToOutputFile: 'Shutdown of SqueakSVNPlugin complete'.
	^ true! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/17/2008 20:46'!
sizeForSvnInfoArray

	^ 12! !

!SqueakSVNPlugin methodsFor: 'old' stamp: 'rkrk 3/12/2008 13:25'!
stringTest01

	| oop ptr aString |

	self export: true.
	self var: #aString declareC: 'char *aString'.
	self var: #ptr declareC: 'char *ptr'.
	self cCode: 'aString = "hallo welt"'.
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: 20.
	ptr := interpreterProxy firstIndexableField: oop.
	0 to: 12"size"-1 do:[:i|
		ptr at: i put: (aString at: i)].
	interpreterProxy
		pop: 1
		thenPush: oop.! !

!SqueakSVNPlugin methodsFor: 'svn adding and deleting' stamp: 'rkrk 3/13/2008 23:29'!
svnAdd: targetOop

	| target |
	self export: true.
	self var: #target declareC: 'char *target'.
	self primitive: 'svnAdd' parameters: #(Oop ).
	
	target := self convertOopToCString: targetOop.
	
	"Call SVNWrapper function"
	self cCode: 'addTargetToWC (target)'. "Todo: check result (int?) for success or failure"
	
	self cCode: 'free(target)'.
	
	^targetOop! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'pe 2/21/2008 13:06'!
svnAddProperty: propertyOop WithValue:valueOop To: targetOop

	| property value target |
	self export: true.
	self var: #property declareC: 'char *property'.
	self var: #value declareC: 'char *value'.
	self var: #target declareC: 'char *target'.
	self primitive: 'svnAddPropertyWithValueTo' parameters: #(Oop Oop Oop).
	
	property := self convertOopToCString: propertyOop.
	value := self convertOopToCString: valueOop.
	target := self convertOopToCString: targetOop.
	
	"Call SVNWrapper function"
	self cCode: 'addPropertyAndValueToTarget (property, value, target)'.
	
	self cCode: 'free(property)'.
	self cCode: 'free(value)'.
	self cCode: 'free(target)'.! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/17/2008 23:39'!
svnAlternativeGetHeadRevision: targetOop

	| resultArray arrayPtr revision target truepath err pegRevision|
	self export: true.
	self
		var: #arrayPtr 		declareC: 'sqInt* arrayPtr';
		var: #revision 		declareC: 'svn_opt_revision_t revision';
		var: #pegRevision 	declareC: 'svn_opt_revision_t pegRevision';
		var: #target 			declareC: 'const char *target';
		var: #truepath 		declareC: 'char *truepath';
		var: #err 			declareC: 'svn_error_t *err'.
	self primitive: 'svnAlternativeGetHeadRevision' parameters: #(Oop).

	target := interpreterProxy arrayValueOf: targetOop.
	
	resultArray := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: self sizeForSvnInfoArray.
	arrayPtr := interpreterProxy firstIndexableField: resultArray.
	
	arrayPtr. revision. target. truepath. pegRevision.
	
	self cCode: 'svn_opt_parse_path(&pegRevision, &truepath, target, pool)'.
	self cCode: 'pegRevision.kind = svn_opt_revision_unspecified'.
	self cCode: 'revision.kind = svn_opt_revision_unspecified'.
	"self cCode: 'revision.value.number = 7'."
	err := self cCode: 'svn_client_info (
		truepath,
		&pegRevision, 					/* peg-revision */
		&revision, 						/* revision ???? */
		svnInfoCbBatonTargetInfoPool,		/* callback */
		(void*) &arrayPtr, 				/* baton */
		FALSE, 							/* no recurse */
		ctx, pool)'.
	err ifTrue: [self handleError: err].
	
	^ resultArray! !

!SqueakSVNPlugin methodsFor: 'svn checkout' stamp: 'rt 2/21/2008 13:41'!
svnCheckoutHeadRevisionFrom: aURLOop to: aPathOop

	| url path |
	self export: true.
	self var: #url declareC: 'char* url'.
	self var: #path declareC: 'char* path'.
	self primitive: 'svnCheckoutHeadRevisionFromTo' parameters: #(Oop Oop ).
	
	url := self convertOopToCString: aURLOop.
	path := self convertOopToCString: aPathOop.
	
	"Call SVNWrapper function"
	self cCode: 'checkoutHeadRevisionFormTo(url, path)'.
	
	self cCode: 'free(url)'.
	self cCode: 'free(path)'! !

!SqueakSVNPlugin methodsFor: 'svn checkout' stamp: 'rt 2/21/2008 15:06'!
svnCheckoutRevisionByNumber: aNumberOop from: aURLOop to: aPathOop

	| revisionNumber url path |
	self export: true.
	self var: #revisionNumber declareC: 'long int revisionNumber'.
	self var: #url declareC: 'char* url'.
	self var: #path declareC: 'char* path'.
	self primitive: 'svnCheckoutRevisionByNumberFromTo' parameters: #(Integer Oop Oop ).
	
	"self cCode: 'revisionNumber = (long int) aNumberOop'."
	revisionNumber := interpreterProxy integerValueOf: aNumberOop.
	url := self convertOopToCString: aURLOop.
	path := self convertOopToCString: aPathOop.
	
	"Call SVNWrapper function"
	self cCode: 'checkoutRevisionByNumberFormTo(revisionNumber, url, path)'.
	
	self cCode: 'free(url)'.
	self cCode: 'free(path)'! !

!SqueakSVNPlugin methodsFor: 'svn commit' stamp: 'pe 3/5/2008 11:56'!
svnCommit: aOopCollectionOfOopTargets WithMessage: aOopMessage

	| targetsArray squeakStrings count cString message |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self var: #message declareC: 'char* message'.
	self primitive: 'svnCommitWithMessage' parameters: #(Oop Oop).
	
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	message := self convertOopToCString: aOopMessage.
	0 to: count - 1 do: [:listIndex |
		cString := self convertOopToCString: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"Call SVNWrapper function"
	self cCode: 'commit( count, targetsArray, message)'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.
	self cCode: 'free( message )'.! !

!SqueakSVNPlugin methodsFor: 'svn adding and deleting' stamp: 'rt 3/10/2008 17:28'!
svnDeleteTargetsFromWorkingCopy: aOopCollectionOfOopTargets

	| targetsArray squeakStrings count cString |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self primitive: 'svnDeleteTargetsFromWorkingCopy' parameters: #(Oop).
	
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self convertOopToCString: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"Call SVNWrapper function"
	self cCode: 'deleteTargetsFromWC( count, targetsArray )'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.
	
	^aOopCollectionOfOopTargets! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'cop 3/11/2008 21:53'!
svnGetBlameLinesFrom: targetOop
	"returns an array like #(rev1 author1 date1 line1 ...)"
	
	| target cArray arrayOop ptr numberOfLines |
	self export: true.
	self var: #target declareC: 'char *target'.
	self var: #cArray declareC: 'char **cArray'.
	self var: #numberOfLines declareC: 'int numberOfLines'.
	self var: #ptr declareC: 'int *ptr'.
	self primitive: 'svnGetBlameLinesFrom' parameters: #(Oop).
	
	target := self convertOopToCString: targetOop.
	
	"get the filled array"
	self cCode: 'getBlameLines(target, &numberOfLines, &cArray)'.

	"Create a Squeak-Array in which the result can be returned"
	arrayOop := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: numberOfLines.
	
	"Copy the entries into the Squeak-Array and free them"
	ptr := interpreterProxy firstIndexableField: arrayOop.
	0 to: numberOfLines - 1 do: [:i |
		ptr at: i put: (self convertCStringToOop: (cArray at: i)).
		self free: (cArray at: i)].
	self free: cArray.
	
	^ arrayOop.! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'pe 3/12/2008 13:14'!
svnGetCommitLogFrom: targetOop with: aNumberOop 
	" returns the logMessage of a given revision "
	"MAYBE TODO: returns a array like #(version1 log1 version2 log2 ...)"
	| target logOop revisionNumber count logMessage |
	self export: true.
	self var: #revisionNumber declareC: 'long int revisionNumber'.
	self var: #target declareC: 'char *target'.
	self var: #logMessage declareC: 'char *logMessage'.
	
	self primitive: 'svnGetCommitLogFromwith' parameters: #(Oop Integer).
	target := self convertOopToCString: targetOop.
	revisionNumber := interpreterProxy integerValueOf: aNumberOop.
	count := 1.
	self cCode: 'getCommitLog(count, target, revisionNumber, &logMessage)'.
	logOop := self convertCStringToOop: logMessage.
	self cCode: 'free(target)'.
	self cCode: 'free(logMessage)'.
	^ logOop! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rt 2/11/2008 14:18'!
svnGetHeadRevision: targetOop

	| target revision |
	self export: true.
	self var: #target declareC: 'char *target'.
	self var: #revision declareC: 'int revision'.
	self primitive: 'svnGetHeadRevision' parameters: #(Oop ).
	
	target := self convertOopToCString: targetOop.
	
	"Call SVNWrapper function"
	self cCode: 'getHeadRevisionOf(target, &revision)'. "Todo: check result (int?) for success or failure"
	
	self cCode: 'free(target)'.
	
	"interpreterProxy
		pop: 1
		thenPush: (interpreterProxy integerObjectOf: revision)."
	^interpreterProxy integerObjectOf: revision! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'rkrk 3/14/2008 15:47'!
svnGetPropertiesFrom: targetOop
	"returns an array like #(key1 value1 key2 value2 ...)"
	
	| target numberOfAllProperties keyAndValueArray arrayOop ptr arraySize |
	self export: true.
	self var: #target declareC: 'char *target'.
	self var: #keyAndValueArray declareC: 'char **keyAndValueArray'.
	self var: #numberOfAllProperties declareC: 'int numberOfAllProperties'.
	self var: #arraySize declareC: 'size_t arraySize'.
	self var: #ptr declareC: 'int *ptr'.
	self primitive: 'svnGetPropertiesFrom' parameters: #(Oop).
	
	"Create an array for keys and for values and pass it to the wrapper.
	It will fill the array with keys at unequal and the values at equal indices"
	target := self convertOopToCString: targetOop.
	target.
	numberOfAllProperties := 0.
	self cCode: 'numberOfProperties(target, &numberOfAllProperties)'.
	arraySize := numberOfAllProperties*2.
	
	"Create a Squeak-Array in which the result can be returned"
	arrayOop := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: arraySize.

	"if there are no properties, go home"
	(arraySize > 0) ifFalse: [^ arrayOop].
	
	"get the keys and values"
	keyAndValueArray := self cCode: '(char**) malloc(sizeof(char *) * arraySize)'.
	self cCode: 'propertyKeyAndValues(target, &keyAndValueArray)'.
	
	"Copy the entries into the Squeak-Array and free them"
	ptr := interpreterProxy firstIndexableField: arrayOop.
	self writeTextToOutputFile: 'Before copying array'.
	0 to: arraySize - 1 do: [:i |
		self writeTextToOutputFile: 'Copy:'.
		self writeTextToOutputFile: (keyAndValueArray at: i).
		ptr at: i put: (self convertCStringToOop: (keyAndValueArray at: i))].
	"Free the allocated memory"
	0 to: arraySize - 1 do: [:i |
		self free: (keyAndValueArray at: i)].
	self writeTextToOutputFile: 'After copying array'.
	self free: keyAndValueArray.
	self writeTextToOutputFile: 'Leaving #svnGetPropertiesFrom:'.
	^ arrayOop.! !

!SqueakSVNPlugin methodsFor: 'svn info' stamp: 'rkrk 3/17/2008 23:31'!
svnInfoCbBaton: baton Target: target Info: info Pool: cbPool

	| arrayPtr |
	self returnTypeC: 'svn_error_t *'.
	self
		var: #baton type: 'void *';
		var: #target type: 'const char *';
		var: #info type: 'const svn_info_t *';
		var: #cbPool type: 'apr_pool_t *'.
	self	var: #arrayPtr declareC: 'sqInt** arrayPtr'.
	
	self writeTextToOutputFile: (self cCode: 'info->URL').
	
	arrayPtr := self cCoerce: baton to: 'sqInt **'.
	self putCString: 	(self cCode: 'info->repos_root_URL') 		in: arrayPtr at: 0.
	self putRevision: 	(self cCode: 'info->rev') 					in: arrayPtr at: 1.
	self putCString: 	(self cCode: 'info->repos_UUID') 			in: arrayPtr at: 2.
	self putRevision: 	(self cCode: 'info->last_changed_rev') 		in: arrayPtr at: 3.
	self putAprDate: 	(self cCode: 'info->last_changed_date') 	in: arrayPtr at: 4.
	self putCString: 	(self cCode: 'info->last_changed_author') 	in: arrayPtr at: 5.
	(self cCode: 'info->has_wc_info')
		ifTrue: [self writeTextToOutputFile: 'YES'.
			self putSchedule: 	(self cCode: 'info->schedule') in: arrayPtr at: 6.
				]
		ifFalse: [self writeTextToOutputFile: 'NO'.].
	"^ <#(repositoryUrl revision repositoryUUID lastChangedRev lastChangeDate lastChangedAuthor)>"
	^ self cCode: 'SVN_NO_ERROR'.
	

     " if (info->text_time)
        SVN_ERR(svn_cl__info_print_time(info->text_time, 
                                        _('Text Last Updated'), pool));
      
      if (info->prop_time)
        SVN_ERR(svn_cl__info_print_time(info->prop_time, 
                                        _('Properties Last Updated'), pool));
      
      if (info->checksum) 
        SVN_ERR(svn_cmdline_printf(pool, _('Checksum: %s\n'),
                                   info->checksum));
      
      if (info->conflict_old) 
        SVN_ERR(svn_cmdline_printf(pool,
                                   _('Conflict Previous Base File: %s\n'),
                                   svn_path_local_style(info->conflict_old,
                                                        pool)));
 
      if (info->conflict_wrk) 
        SVN_ERR(svn_cmdline_printf
                (pool, _('Conflict Previous Working File: %s\n'),
                 svn_path_local_style(info->conflict_wrk, pool)));
      
      if (info->conflict_new) 
        SVN_ERR(svn_cmdline_printf(pool,
                                   _('Conflict Current Base File: %s\n'),
                                   svn_path_local_style(info->conflict_new,
                                                        pool)));
 
      if (info->prejfile) 
        SVN_ERR(svn_cmdline_printf(pool, _('Conflict Properties File: %s\n'),
                                   svn_path_local_style(info->prejfile,
                                                        pool)));"! !

!SqueakSVNPlugin methodsFor: 'svn update' stamp: 'rt 2/21/2008 15:10'!
svnUpdateTargets: aOopCollectionOfOopTargets toRevisionByNumber: aNumberOop

	| targetsArray squeakStrings count cString revisionNumber |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self var: #revisionNumber declareC: 'long int revisionNumber'.
	self primitive: 'svnUpdateTargetsToRevisionByNumber:' parameters: #(Oop Integer ).
	
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self convertOopToCString: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"self cCode: 'revisionNumber = (long int) aNumberOop'."
	revisionNumber := interpreterProxy integerValueOf: aNumberOop.
	"Call SVNWrapper function"
	self cCode: 'updateTargetsToRevisionByNumber( count, targetsArray , revisionNumber )'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.! !

!SqueakSVNPlugin methodsFor: 'svn update' stamp: 'rt 2/21/2008 13:37'!
svnUpdateTargetsToHeadRevision: aOopCollectionOfOopTargets

	| targetsArray squeakStrings count cString |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self primitive: 'svnUpdateTargetsToHeadRevision' parameters: #(Oop ).
	
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self convertOopToCString: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"Call SVNWrapper function"
	self cCode: 'updateTargetsToHeadRevision( count, targetsArray )'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.! !
